-----------------------------------------------------------------------------------------------
-- Client Lua Script for DeathCounter
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
-----------------------------------------------------------------------------------------------
-- DeathCounter Module Definition
-----------------------------------------------------------------------------------------------
local DeathCounter = {} 
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
DeathCounter.LineObject = nil

function DeathCounter:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function DeathCounter:Init()
    Apollo.RegisterAddon(self, false)
end
 
-----------------------------------------------------------------------------------------------
-- DeathCounter OnLoad
-----------------------------------------------------------------------------------------------
function DeathCounter:OnLoad()
	self.config = Apollo.GetPackage("Gemini:DB-1.0").tPackage:New(self)
	
	if self.config.char.DeathCounter == nil then
		self.config.char.DeathCounter = 0
	end
	
	if AddCharacterInformationLine ~= nil then
		self.LineObject = AddCharacterInformationLine(
		"DeathCounter",
		"Death",
		function() 			
			return self.config.char.DeathCounter 
		end,
		nil, 
		nil,
		"This is the number of times your died.")
	else
		self.LineObject = nil
	end

	
	Apollo.RegisterEventHandler("ShowResurrectDialog", "OnShowResurrectDialog", self)
	--SendVarToRover("Character",GameLib:GetPlayerUnit())
end

function DeathCounter:OnShowResurrectDialog()
	
	if GameLib:GetPlayerUnit():IsDead() then
		self.config.char.DeathCounter = self.config.char.DeathCounter + 1
		if self.LineObject == nil then
			Print("<DeathCounter> You need to install the addon 'CharacterInfoPlus' (http://www.curse.com/ws-addons/wildstar/222978-characterinfoplus) to see the new amount into the character window.")
		else
			self.LineObject:forceUpdate()
		end
	end
end

-----------------------------------------------------------------------------------------------
-- DeathCounter Instance
-----------------------------------------------------------------------------------------------
local DeathCounterInst = DeathCounter:new()
DeathCounterInst:Init()
